program nxpextract;

uses
  paszlib,
  Classes, SysUtils;

var
  NXP: TFileStream;

  NameLength: UInt16;
  FileName: String;
  WorkingStream, OutStream: TMemoryStream;
  CmpSize, DmpSize: LongWord;

  FileCount: Integer;

  i: Integer;

begin
  FileCount := 0;
  NameLength := 0;
  DmpSize := 0;
  CmpSize := 0;

  if ParamStr(1) = '' then
  begin
    WriteLn('Usage: ' + ExtractFileName(ParamStr(0)) + ' <NXP filename>');
    WriteLn('Alternatively, drag and drop an NXP file onto the EXE.');
  end else begin
    ForceDirectories(ChangeFileExt(ParamStr(1), '') + '\');

    WorkingStream := TMemoryStream.Create;
    OutStream := TMemoryStream.Create;
    NXP := TFileStream.Create(ParamStr(1), fmOpenRead);
    try
      SetCurrentDir(ChangeFileExt(ParamStr(1), '') + '\');

      NXP.Position := 3;
      NXP.Read(FileCount, 4);

      NXP.Position := $002C;
      for i := 0 to FileCount - 1 do
      begin
        NXP.Read(NameLength, 2);
        FileName := StringOfChar(' ', NameLength);
        NXP.Read(FileName[1], NameLength);

        WriteLn(FileName);
        WriteLn('  @' + IntToHex(NXP.Position, 8));

        NXP.Position := NXP.Position + 1;

        NXP.Read(DmpSize, 4);
        NXP.Read(CmpSize, 4);

        NXP.Position := NXP.Position + 40;

        if (CmpSize > 0) then
        begin
          NXP.Position := NXP.Position + 8; // Next 8 bytes are just a duplicate of DmpSize / CmpSize
          CmpSize := CmpSize - 8; // But the earlier CmpSize includes them in the count

          WriteLn('  #' + IntToHex(DmpSize, 8));
          WriteLn('  *' + IntToHex(CmpSize, 8));

          WorkingStream.Clear;
          WorkingStream.CopyFrom(NXP, CmpSize);

          OutStream.Clear;
          OutStream.SetSize(DmpSize);

          uncompress(OutStream.Memory, DmpSize, WorkingStream.Memory, CmpSize);
        end else begin
          WriteLn('  Empty file');
          OutStream.Clear;
        end;

        OutStream.SaveToFile(FileName);
        WriteLn('');
      end;
    finally
      NXP.Free;
      WorkingStream.Free;
      OutStream.Free;
    end;
  end;
end.

